> ## Documentation Index
> Fetch the complete documentation index at: https://docs.smokeball.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Request plugin URL

> Requests a secure URL from the plugin's endpoint for invoking the plugin.
Accepts additional key/value pairs to pass to the plugin endpoint.
Reserved keys (AccountId, UserId, UserEmail, MatterId, AppId, EmbedToken) cannot be included in AdditionalData.



## OpenAPI

````yaml /openapi.json post /plugins/{pluginId}/url
openapi: 3.0.1
info:
  title: API
  version: '1.0'
servers:
  - url: https://api.smokeball.com
  - url: https://api.smokeball.com.au
  - url: https://api.smokeball.co.uk
  - url: https://stagingapi.smokeball.com
  - url: https://stagingapi.smokeball.com.au
  - url: https://stagingapi.smokeball.co.uk
security:
  - api-key: []
    token: []
paths:
  /plugins/{pluginId}/url:
    post:
      tags:
        - Plugins
      summary: Request plugin URL
      description: "Requests a secure URL from the plugin's endpoint for invoking the plugin.\r\nAccepts additional key/value pairs to pass to the plugin endpoint.\r\nReserved keys (AccountId, UserId, UserEmail, MatterId, AppId, EmbedToken) cannot be included in AdditionalData."
      operationId: RequestPluginUrlAsync
      parameters:
        - name: pluginId
          in: path
          required: true
          schema:
            type: string
            format: uuid
      requestBody:
        content:
          application/json-patch+json:
            schema:
              allOf:
                - $ref: '#/components/schemas/PluginUrlRequestDto'
          application/json:
            schema:
              allOf:
                - $ref: '#/components/schemas/PluginUrlRequestDto'
          application/*+json:
            schema:
              allOf:
                - $ref: '#/components/schemas/PluginUrlRequestDto'
      responses:
        '200':
          description: When request is successful. Returns the plugin URL.
          content:
            application/json:
              schema:
                type: string
        '400':
          description: When plugin does not return a valid URL or reserved keys are used.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ProblemDetails'
        '401':
          description: When request is not authenticated with client credentials.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ProblemDetails'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ProblemDetails'
        '404':
          description: When plugin with specified id does not exist.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ProblemDetails'
components:
  schemas:
    PluginUrlRequestDto:
      type: object
      properties:
        matterId:
          type: string
          description: The matter id associated with the request, if applicable.
          nullable: true
          example: 0c5a2296-9e02-4c58-bd14-b7467d4c9bcb
        additionalData:
          type: object
          additionalProperties: {}
          description: "Additional key/value pairs to pass to the plugin endpoint.\r\nReserved keys (AccountId, UserId, UserEmail, MatterId) will be rejected."
          nullable: true
      additionalProperties: false
    ProblemDetails:
      type: object
      properties:
        type:
          type: string
          nullable: true
        title:
          type: string
          nullable: true
        status:
          type: integer
          format: int32
          nullable: true
        detail:
          type: string
          nullable: true
        instance:
          type: string
          nullable: true
      additionalProperties: {}
  securitySchemes:
    api-key:
      type: apiKey
      name: x-api-key
      in: header
    token:
      type: apiKey
      name: Authorization
      in: header
      x-amazon-apigateway-authtype: cognito_user_pools

````